searchNodes=[{"doc":"This is the main SuperCollider module. With this module, you can: start a SuperCollider.SoundServer , which is a GenServer used to communicate with scynth and recieve messages from it. issue commands access SuperColliders state. This module aims to minimise the need to pass a pid around representing the active SoundServer by storing it's PID as a persisitient term under :supercollider_soundserver . Calling SuperCollider.start() will automatically store the pid of the SoundServer as a persistient term. Example alias SuperCollider , as :SC # Start the `SuperCollider.SoundServer` GenServer SC . start ( ) # this will return the PID of the SoundServer, however, you don&#39;t have to assign this to a variable as its stored as a persistient term used by the other functions in this module. # Issue the verion command and get the response from SoundServer&#39;s state SC . command ( :version ) # send the version commant to SuperCollider SC . response ( :version ) # retrieves the version response from the SoundServer&#39;s state # Play a sine wave UGen on node 600, with a frequency of 300 SC . command ( :s_new , [ &quot;sine&quot; , 600 , 1 , 1 , [ &quot;freq&quot; , 300 ] ] ) # Stop the sine wave by freeing node 600 SC . command ( :n_free , 600 )","ref":"SuperCollider.html","title":"SuperCollider","type":"module"},{"doc":"Send a command to the default SoundServer. This function accepts the following parameters: command, in a form of an atom representing SuperCollider commands (See: SuperCollider.SoundServer.Command for details) Examples # Get the server&#39;s status SuperCollider . command ( :status ) # Make the call SuperCollider . response ( :status ) # Get the status response data","ref":"SuperCollider.html#command/1","title":"SuperCollider.command/1","type":"function"},{"doc":"Send a command to the default SoundServer with arguments. This function accepts the following parameters: command, in a form of an atom representing SuperCollider commands (See: SuperCollider.SoundServer.Command for details) args, commands which take them. Multiple options can be provided as a list. Examples # Send a command to play a basic 300Hz sinusoidal sound on node 100 SuperCollider . command ( :s_new , [ &quot;sine&quot; , 100 , 1 , 1 , [ &quot;freq&quot; , 300 ] ] ) # Stop the sound by freeing node 100 SuperCollider . command ( :n_free , 100 )","ref":"SuperCollider.html#command/2","title":"SuperCollider.command/2","type":"function"},{"doc":"Returns the PID of the SoundServer stored as a persistent_term as :supercollider_soundserver.","ref":"SuperCollider.html#pid/0","title":"SuperCollider.pid/0","type":"function"},{"doc":"Get's any OSC responses stored in the state of the SoundServer . Responses are stored in a Map. If there are no responses stored, an empty map is returned, e.g. %{} .","ref":"SuperCollider.html#response/0","title":"SuperCollider.response/0","type":"function"},{"doc":"Get's a specific OSC response stored in the state of the server, by it's key. If no response is available for the specific key, nil is returned. The following are currently stored responses: :version - the version information from a SuperCollider.command(:version) call :status - the last status message stored from a SuperCollider.command(:status) call :fail - the last fail message from a SuperCollider.command(...) call Example For example, if a version request was made: SuperCollider . command ( :version ) To get the response held by the SuperCollider.SoundServer you'd call: SuperCollider . response ( :version ) This would return the version response in the following format: [ { &quot;Program name. May be &quot; scsynth &quot; or &quot; supernova &quot;.&quot; , &quot;scsynth&quot; } , { &quot;Major version number. Equivalent to sclang&#39;s Main.scVersionMajor.&quot; , 3 } , { &quot;Minor version number. Equivalent to sclang&#39;s Main.scVersionMinor.&quot; , 13 } , { &quot;Patch version name. Equivalent to the sclang code &quot; . &quot; ++ Main.scVersionPatch ++ Main.scVersionTweak.&quot; , &quot;.0&quot; } , { &quot;Git branch name.&quot; , &quot;Version-3.13.0&quot; } , { &quot;First seven hex digits of the commit hash.&quot; , &quot;3188503&quot; } ]","ref":"SuperCollider.html#response/1","title":"SuperCollider.response/1","type":"function"},{"doc":"Starts the SuperCollider.SoundServer GenServer and returns it's pid. The pid for the SuperCollider.SoundServer is also stored as a persisitient term under :supercollider_soundserver . This is used by the SuperCollider.state/0 , SuperCollider.response/0 , SuperCollider.response/1 , SuperCollider.command/1 and SuperCollider.command/2 functions so that they're passed the global SoundServer pid without having to specify it. If you want to directly interact with a SoundServer through it's pid, see the equivalent functions under SuperCollider.SoundServer , such as {:ok, pid} = SuperCollider.SoundServer.start_link() or through {:ok, pid} = GenServer.start_link(SoundServer, SoundServer.new()) . Options Additionally, this function can take options: ip: the IP address of scserver. This defaults to '127.0.0.1' hostname: the hostname of the server. This defaults to 'localhost'. port: the port used to communicate with scserver. This defaults to 57110. socket: the UDP socket used to communicate with scserver, once the connection is open. type: the server type being used, accepts :scsynth (default) or :supernova (multicore) Note if the hostname is set to nil it will try the IP address at ip . Examples Start SuperCollider with defaults SuperCollider . start ( ) Start SuperCollider with a supernova server SuperCollider . start ( type : :supernova ) This function starts the SuperCollider.SoundServer GenServer which will check if SuperCollider has booted on your system. If not, it will currently attempt to start scynth or supernova at the following locations: Mac: /Applications/SuperCollider.app/Contents/Resources/ Linux: /usr/local/ Windows: \\Program Files\\SuperCollider\\","ref":"SuperCollider.html#start/1","title":"SuperCollider.start/1","type":"function"},{"doc":"Get's the state of the global SoundServer (whos PID is stored as a persisitient term under :supercollider_soundserver ). Example SuperCollider . state ( ) ## Returns the populated SoundServer struct # %SuperCollider.SoundServer{ # ip: &#39;127.0.0.1&#39;, # hostname: &#39;localhost&#39;, # port: 57110, # socket: #Port&lt;0.12&gt;, # type: :supernova, # responses: %{} # }","ref":"SuperCollider.html#state/0","title":"SuperCollider.state/0","type":"function"},{"doc":"The SynthDef is module and struct for SuperCollider Synthesis Definitions. This module includes functions for: converting a binary scsyndef to a %SynthDef{} struct with from_file/1 encoding %SynthDef{} to the binary scsyndef file format with to_binary/1 . The SynthDef struct contains the: the name of the synth definition list of constant values list of initial parameter values (floats) list of named parameters and their index list of UGens (using the %SuperCollider.SynthDef.UGen{} struct) list of named varient specs (named key-value pairs with the value as a float.) TODO: Currently there isn't a 'friendly' DSL for creating SynthDefs but that is on the roadmap! Example - create a SynthDef from scratch This example: creates a brown-noise SynthDef encodes it to binary format sends it to SuperCollider (scsynth or supernova) plays it by sending the :s_new command stops it by sending the :n_free command # Define the brown noise SynthDef and call it &#39;ambient&#39; brown_noise_synthdef = [ % SuperCollider.SynthDef { name : &quot;ambient&quot; , constant_values_list : [ 0.2 ] , parameter_values_list : [ 0.0 ] , parameter_names_list : [ %{ parameter_index : 0 , parameter_name : &quot;out&quot; } ] , ugen_specs_list : [ % SuperCollider.SynthDef.UGen { class_name : &quot;Control&quot; , calculation_rate : 1 , special_index : 0 , input_specs_list : [ ] , output_specs_list : [ %{ _enum_count : 0 , calculation_rate : 1 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;BrownNoise&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ ] , output_specs_list : [ %{ _enum_count : 0 , calculation_rate : 2 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;BinaryOpUGen&quot; , calculation_rate : 2 , special_index : 2 , input_specs_list : [ %{ index : 1 , output_index : 0 , type : :ugen } , %{ index : 0 , type : :constant } ] , output_specs_list : [ %{ _enum_count : 0 , calculation_rate : 2 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;Out&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ %{ index : 0 , output_index : 0 , type : :ugen } , %{ index : 2 , output_index : 0 , type : :ugen } ] , output_specs_list : [ ] } ] , varient_specs_list : [ ] } ] Encode the SynthDef into binary format: sc_binary = SynthDef . to_binary ( brown_noise_synthdef ) Assuming SuperCollider (scsynth or supernova) is running and SuperCollider.SoundServer has been started, e.g. through SuperCollider.start() , you can send this binary SynthDef to the server and play it! Send the binary to SuperCollider server (scsynth or supernova): SuperCollider . command ( :d_recv , sc_binary ) You can then play the brown noise by issuing the following command. This will load it on node 100: SuperCollider . command ( :s_new , [ &quot;ambient&quot; , 100 , 1 , 0 , [ ] ] ) You can stop it by freeing node 100: SuperCollider . command ( :n_free , 100 )","ref":"SuperCollider.SynthDef.html","title":"SuperCollider.SynthDef","type":"module"},{"doc":"Parses syndef binary data. This function is not usually called directly, but is automatically called as part of ScFile.parse(filename) . Parsing of the SynthDef is in the following order: name (of synthdef) constants parameters parameter names UGen specs varient specs. Returns a tuple in the format {%SynthDef{}, binary_data} . binary_data should be empty if all data was successfully parsed.","ref":"SuperCollider.SynthDef.html#decode/1","title":"SuperCollider.SynthDef.decode/1","type":"function"},{"doc":"Encodes SynthDefs into SuperCollider's binary format. It takes as its first parameter either a list of %SynthDef{} or an individual %SynthDef{} . This function is not usually called directly, but is automatically called as part of SuperCollider.SynthDef.ScFile.encode(synthdef) .","ref":"SuperCollider.SynthDef.html#encode/1","title":"SuperCollider.SynthDef.encode/1","type":"function"},{"doc":"Parses a SuperCollider .scynthdef binary file into an %ScFile{} struct. This function is similar to SuperCollider.SynthDef.ScFile.parse/1 except this function will only return the list of %SyntDef{} 's contained in the file, and not any of the other file metadata. Example SynthDef . from_file ( &quot;ambient.scsyndef&quot; ) # Returns the list of SynthDef&#39;s contained in the file, without the additional file metadata, e.g.: # [ # %SuperCollider.SynthDef{ # name: &quot;ambient&quot;, # constant_values_list: [0.2], # parameter_values_list: [0.0], # parameter_names_list: [%{parameter_index: 0, parameter_name: &quot;out&quot;}], # ugen_specs_list: [ # %SuperCollider.SynthDef.UGen{ # class_name: &quot;Control&quot;, # calculation_rate: 1, # special_index: 0, # input_specs_list: [], # output_specs_list: [%{_enum_count: 0, calculation_rate: 1}] # }, # %SuperCollider.SynthDef.UGen{ # class_name: &quot;BrownNoise&quot;, # calculation_rate: 2, # special_index: 0, # input_specs_list: [], # output_specs_list: [%{_enum_count: 0, calculation_rate: 2}] # }, # %SuperCollider.SynthDef.UGen{ # class_name: &quot;BinaryOpUGen&quot;, # calculation_rate: 2, # special_index: 2, # input_specs_list: [ # %{index: 1, output_index: 0, type: :ugen}, # %{index: 0, type: :constant} # ], # output_specs_list: [%{_enum_count: 0, calculation_rate: 2}] # }, # %SuperCollider.SynthDef.UGen{ # class_name: &quot;Out&quot;, # calculation_rate: 2, # special_index: 0, # input_specs_list: [ # %{index: 0, output_index: 0, type: :ugen}, # %{index: 2, output_index: 0, type: :ugen} # ], # output_specs_list: [] # } # ], # varient_specs_list: [] # } # ]","ref":"SuperCollider.SynthDef.html#from_file/1","title":"SuperCollider.SynthDef.from_file/1","type":"function"},{"doc":"Defines a new SynthDef. Takes a list of key-values used to populate the %SynthDef{} struct. A SynthDef consists of the following: name (of synthdef) constants parameters parameter names UGen specs varient specs Example SynthDef . new ( ) # Returns an empty struct by default: # %SuperCollider.SynthDef{ # name: nil, # constant_values_list: nil, # parameter_values_list: nil, # parameter_names_list: nil, # ugen_specs_list: nil, # varient_specs_list: nil # } SynthDef . new ( name : &quot;MySynthdef&quot; ) # Returns the struct with the name populated: # %SuperCollider.SynthDef{ # name: &quot;MySynthdef&quot;, # ... # }","ref":"SuperCollider.SynthDef.html#new/1","title":"SuperCollider.SynthDef.new/1","type":"function"},{"doc":"Encodes one or more %SynthDef{} into SuperCollider's binary file format. This function is the same as SuperCollider.SynthDef.ScFile.encode/1 . See the top of this page (module doc) for an example of to_binary/1 .","ref":"SuperCollider.SynthDef.html#to_binary/1","title":"SuperCollider.SynthDef.to_binary/1","type":"function"},{"doc":"UGens represent calculations with signals. They are the basic building blocks of synth definitions on the server, and are used to generate or process both audio and control signals. They're made up of: class_name - Examples include SinOsc , Out , and Control . rate - The rate at which the UGen computes values. There are three rates numbered 0, 1, 2. special_index - This value is used by some unit generators for a special purpose. For example, UnaryOpUGen and BinaryOpUGen use it to indicate which operator to perform. If not used it should be set to zero. inputs - The inputs to this unit generator outputs - The list of outputs of this unit generator. Each element in the list is the rate of the output, using the same number as the rate field of this struct.","ref":"SuperCollider.SynthDef.UGen.html","title":"SuperCollider.SynthDef.UGen","type":"module"},{"doc":"The parse function is used as part deconstructing UGen binary data in SuperCollider scsyndef v2 files. It is not usually accessed directly, but is called via SuperCollider.SynthDef.ScFile.parse(filename) .","ref":"SuperCollider.SynthDef.UGen.html#decode/1","title":"SuperCollider.SynthDef.UGen.decode/1","type":"function"},{"doc":"Encodes UGens into SuperCollider's binary format. This function is not usually called directly, but is automatically called as part of SuperCollider.SynthDef.ScFile.encode(synthdef) .","ref":"SuperCollider.SynthDef.UGen.html#encode/2","title":"SuperCollider.SynthDef.UGen.encode/2","type":"function"},{"doc":"GenServer for communicating with scserver or supernova. This module is a: GenServer which is used to communicate with SuperCollider's scserver or supernova Struct which holds the server's basic state and configuration. Basic configuration Buy default, it looks for scynth at 127.0.0.1 or localhost on port 57110. Starting a server alias SuperCollider.SoundServer { :ok , pid } = GenServer . start_link ( SoundServer , SoundServer . new ( opts ) ) Requesting the server's status SoundServer . command ( pid , :status ) # If scynth returned an OSC status response message, you can access it by fetching the SoundServer&#39;s state, accessing the responses map and status key: SoundServer . state ( pid ) . responses [ :status ] # Returns: # [ # {&quot;unused&quot;, 1}, # {&quot;number of unit generators&quot;, 0}, # {&quot;number of synths&quot;, 0}, # {&quot;number of groups&quot;, 2}, # {&quot;number of loaded synth definitions&quot;, 109}, # {&quot;average percent CPU usage for signal processing&quot;, 0.026054037734866142}, # {&quot;peak percent CPU usage for signal processing&quot;, 0.07464269548654556}, # {&quot;nominal sample rate&quot;, 44100.0}, # {&quot;actual sample rate&quot;, 44099.97125381111} # ] Play a sine wave UGen # Play a sine wave UGen on node 600, with a frequency of 300 SoundServer . command ( pid , :s_new , [ &quot;sine&quot; , 600 , 1 , 1 , [ &quot;freq&quot; , 300 ] ] ) # Stop the sine wave by freeing node 600 SoundServer . command ( pid , :n_free , 600 )","ref":"SuperCollider.SoundServer.html","title":"SuperCollider.SoundServer","type":"module"},{"doc":"The SoundServer struct colds the servers basic state: ip: the IP address of scserver. This defaults to '127.0.0.1' hostname: the hostname of the server. This defaults to 'localhost'. port: the port used to communicate with scserver. This defaults to 57110. socket: the UDP socket used to communicate with scserver, once the connection is open. type: which SuperCollider server is being used, accepts :scsynth (default) or :supernova (multicore)","ref":"SuperCollider.SoundServer.html#__struct__/0","title":"SuperCollider.SoundServer.__struct__/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"SuperCollider.SoundServer.html#child_spec/1","title":"SuperCollider.SoundServer.child_spec/1","type":"function"},{"doc":"Sends an OSC command to SuperCollider (scynth or supernova). SuperCollider.SoundServer.command(pid, :version) will sendthe OSC 'version' command. Optionally accepts arguments, depending on the command being called. Commands must be a valid commmand (function in the SuperCollider.SoundServer.Command module) and match it's arity, otherwise an {:error, reason} tuple ie returned.","ref":"SuperCollider.SoundServer.html#command/2","title":"SuperCollider.SoundServer.command/2","type":"function"},{"doc":"","ref":"SuperCollider.SoundServer.html#command/3","title":"SuperCollider.SoundServer.command/3","type":"function"},{"doc":"When sending calls to scserver though UDP, a response message may be returned in the following format: {:udp, process_port, ip_addr, port_num, osc_response} The handle_info/2 callback will forward these messages to Response.process_osc_message/2 for handling. The handler code must return the updated SoundServer struct for a valid state to be maintained. To get the messages, use SuperCollider.response() .","ref":"SuperCollider.SoundServer.html#handle_info/2","title":"SuperCollider.SoundServer.handle_info/2","type":"function"},{"doc":"The init callback accepts %SoundServer{} struct holding the initial configuration and state. If none is provided, defaults are used. Calls the run/1 function which will check if SuperCollider is loaded and start OSC communication. See the run/1 function for more details","ref":"SuperCollider.SoundServer.html#init/1","title":"SuperCollider.SoundServer.init/1","type":"function"},{"doc":"Checks if scsynth is loaded by calling scsynth_booted?/1 . If not it will attempt to boot it asynchronously using Task.async/1 . Currently attempts to start scynth or supernova at the following locations: Mac: /Applications/SuperCollider.app/Contents/Resources/ Linux: /usr/local/ Windows: \\Program Files\\SuperCollider\\ TODO: The location of the scysnth binary is currently set to the fixed locations above, but this will need to be moved out into a config or using different search strategies for different OSes.","ref":"SuperCollider.SoundServer.html#maybe_boot_scsynth/1","title":"SuperCollider.SoundServer.maybe_boot_scsynth/1","type":"function"},{"doc":"A convience function to create a new SoundServer struct. The struct holds the basic state and configuration. The default values can be overrided by providing a keyword list using the same keys used in the struct. For example: SoundServer . new ( hostname : &#39;othersoundserver&#39; ) will override the default hostname of 'localhost'. For more information, see the SoundServer struct documentation.","ref":"SuperCollider.SoundServer.html#new/1","title":"SuperCollider.SoundServer.new/1","type":"function"},{"doc":"Open's a UDP connection. Unless a port number is provided, by default it will use port 0. Uses :gen_udp.open from Erlang which associates a UDP port number with the calling process (this GenServer).","ref":"SuperCollider.SoundServer.html#open/1","title":"SuperCollider.SoundServer.open/1","type":"function"},{"doc":"Runs the server. By default, this function is executed when init is called. This function: checks if server is loaded, otherwise attempts to boot it opens a USP socket for Open Sound Communication (OSC) communication with the server.","ref":"SuperCollider.SoundServer.html#run/1","title":"SuperCollider.SoundServer.run/1","type":"function"},{"doc":"Checks if scsynth or supernova is booted. It does this by sending the OSC command '/status' through the previously opened UDP port to the address that scsynth is expected. It then waits up to 5 seconds to see if a UDP packet is returned. This function returns: true if if a '/status.reply' message was recieved via UDP. false if either a non-compliant message is recieved or no message is recieved after 5 seconds. In this case the scsynth has been considered not to be loaded. Note: an UDP socket must be set on the %SoundServer{} state, e.g.: soundserver = % SuperCollider.SoundServer { socket : # Port &lt; 0.8 &gt; , # Socket established here, otherwise this would be nil ip : &#39;127.0.0.1&#39; , hostname : &#39;localhost&#39; , port : 57110 , type : :scsynth , responses : %{ } } SuperCollider.SoundServer . scsynth_booted? ( soundserver ) # Returns true if booted If you don't have a curently opened socket, you can get one by calling SoundServer.open/1 , e.g.: { :ok , socket } = SoundServer . open ( ) soundserver = SoundServer . new ( socket : socket ) # Returns SoundServer struct with socket populated: # %SuperCollider.SoundServer{ # socket: #Port&lt;0.9&gt;, # ip: &#39;127.0.0.1&#39;, # hostname: &#39;localhost&#39;, # port: 57110, # type: :scsynth, # responses: %{} # } SuperCollider.SoundServer . scsynth_booted? ( soundserver ) # If already booted returns true # 11:53:43.734 [info] scsynth - already booted ✅ # true Sockets are automatically created when SoundServer is booted in the typical way through SoundServer.start_link or SuperCollider.start .","ref":"SuperCollider.SoundServer.html#scsynth_booted?/1","title":"SuperCollider.SoundServer.scsynth_booted?/1","type":"function"},{"doc":"Starts the SuperCollider.SoundServer GenServer. You can override the default configuration by passing a keyword list with the new values. Currently the following can be set: ip: the IP address of scserver. This defaults to '127.0.0.1' hostname: the hostname of the server. This defaults to 'localhost'. port: the port used to communicate with scserver. This defaults to 57110. socket: the UDP socket used to communicate with scserver, once the connection is open. Example # Start SoundServer with default configuration { :ok , pid } = SuperCollider.SoundServer . start_link ( ) # Start SoundServer specifying scynth&#39;s port to 57000 { :ok , pid } = SuperCollider.SoundServer . start_link ( port : 57000 )","ref":"SuperCollider.SoundServer.html#start_link/1","title":"SuperCollider.SoundServer.start_link/1","type":"function"},{"doc":"Returns the current state of the server. For example, calling SuperCollider.SoundServer.state(pid) will return the populated state struct, which includes configuration and any scynth OSC message responses stored in the reponses key: % SuperCollider.SoundServer { ip : &#39;127.0.0.1&#39; , hostname : &#39;localhost&#39; , port : 57110 , socket : # Port &lt; 0.7 &gt; , responses : %{ fail : [ &quot;/n_free&quot; , &quot;Node 100 not found&quot; ] , status : [ { &quot;unused&quot; , 1 } , { &quot;number of unit generators&quot; , 0 } , { &quot;number of synths&quot; , 0 } , { &quot;number of groups&quot; , 2 } , { &quot;number of loaded synth definitions&quot; , 109 } , { &quot;average percent CPU usage for signal processing&quot; , 0.026054037734866142 } , { &quot;peak percent CPU usage for signal processing&quot; , 0.07464269548654556 } , { &quot;nominal sample rate&quot; , 44100.0 } , { &quot;actual sample rate&quot; , 44099.97125381111 } ] , version : [ { &quot;Program name. May be &quot; scsynth &quot; or &quot; supernova &quot;.&quot; , &quot;scsynth&quot; } , { &quot;Major version number. Equivalent to sclang&#39;s Main.scVersionMajor.&quot; , 3 } , { &quot;Minor version number. Equivalent to sclang&#39;s Main.scVersionMinor.&quot; , 13 } , { &quot;Patch version name. Equivalent to the sclang code &quot; . &quot; ++ Main.scVersionPatch ++ Main.scVersionTweak.&quot; , &quot;.0&quot; } , { &quot;Git branch name.&quot; , &quot;Version-3.13.0&quot; } , { &quot;First seven hex digits of the commit hash.&quot; , &quot;3188503&quot; } ] } }","ref":"SuperCollider.SoundServer.html#state/1","title":"SuperCollider.SoundServer.state/1","type":"function"},{"doc":"This module is used to send Open Sound Control (OSC) commands to SuperCollider's server (scsynth or supernova) via UDP. These commands make use of the server configuration and state details in %SoundServer{}, and is most cases, a %SoundServer{} struct is passed as the first parameter in these funtions. For an official list of these commands, see: https://doc.sccode.org/Reference/Server-Command-Reference.html Structure of this module The functions of this module are grouped into the following categories: scserver communication helper functions, such as to encode OSC messages and to send them to a scserver insrtance scserver commands, following the SuperCollider Server Synth Engine Command Reference: General Commands - such as for getting status or version information or quitting scynth/supernova. Node Commands - for manipulating nodes including freeing them Synth Commands - such as for sending or loading synth defs, and creating a new synth Group Commands Unit Generator Commands Buffer Commands Control Bus Commands Non Real Time Mode Commands Replies to Commands Node Notifications from Server Trigger Notification Buffer Fill Commands. Note that this library uses the OSC style string format to send commands, rather than command numbers.","ref":"SuperCollider.SoundServer.Command.html","title":"SuperCollider.SoundServer.Command","type":"module"},{"doc":"Clear all scheduled bundles. Removes all bundles from the scheduling queue.","ref":"SuperCollider.SoundServer.Command.html#clear_sched/1","title":"SuperCollider.SoundServer.Command.clear_sched/1","type":"function"},{"doc":"Send a plug-in defined command. Commands are defined by plug-ins. This function takes: command name (String) any arguments (As a list []).","ref":"SuperCollider.SoundServer.Command.html#cmd/3","title":"SuperCollider.SoundServer.Command.cmd/3","type":"function"},{"doc":"Deleted (removes) a synth definition. The second parameter is a string representing the name of the synth. The definition is removed immediately, and does not wait for synth nodes based on that definition to end.","ref":"SuperCollider.SoundServer.Command.html#d_free/2","title":"SuperCollider.SoundServer.Command.d_free/2","type":"function"},{"doc":"Loads a file of synth definitions. The second and third parameter are: pathname of the file (string). Can be a pattern like &quot;synthdefs/perc-*&quot; OSC message to execute upon completion. (optional) Replies to sender with /done when complete.","ref":"SuperCollider.SoundServer.Command.html#d_load/3","title":"SuperCollider.SoundServer.Command.d_load/3","type":"function"},{"doc":"Loads a directory of synth definitions files. The second and third parameter are: pathname of the directory (string) OSC message to execute upon completion. (optional) Replies to sender with /done when complete.","ref":"SuperCollider.SoundServer.Command.html#d_load_dir/3","title":"SuperCollider.SoundServer.Command.d_load_dir/3","type":"function"},{"doc":"Instructs the sound server (scsynth or supernova) to receive a synth definition file. This function takes as it's second and third parameter: bytes of data which contain the file of synth definition(s) OSC message to execute upon completion (optional). Replies to sender with /done when complete.","ref":"SuperCollider.SoundServer.Command.html#d_recv/3","title":"SuperCollider.SoundServer.Command.d_recv/3","type":"function"},{"doc":"","ref":"SuperCollider.SoundServer.Command.html#dump_OSC/2","title":"SuperCollider.SoundServer.Command.dump_OSC/2","type":"function"},{"doc":"Displays incoming OSC messages. Turns on and off printing of the contents of incoming Open Sound Control messages. This is useful when debugging your command stream. Accepts one of the following integers as the second parameter: 0 turn dumping OFF. 1 print the parsed contents of the message. 2 print the contents in hexadecimal. 3 print both the parsed and hexadecimal representations of the contents.","ref":"SuperCollider.SoundServer.Command.html#dump_osc/2","title":"SuperCollider.SoundServer.Command.dump_osc/2","type":"function"},{"doc":"Takes an address and a list of optional arguments and encodes them as an OSC message. Mainly used by send_osc/3 as a helper function.","ref":"SuperCollider.SoundServer.Command.html#encode_osc/2","title":"SuperCollider.SoundServer.Command.encode_osc/2","type":"function"},{"doc":"Enable/disable error message posting. Turn on or off error messages sent to the SuperCollider post window. Useful when sending a message, such as /n_free, whose failure does not necessarily indicate anything wrong. Takes an integer as the second parameter: 0 turn off error posting until the next ['/error', 1] message. 1 turn on error posting. For convenience of client-side methods, you can also suppress errors temporarily, for the scope of a single bundle. To do that use the following codes: -1 turn off locally in the bundle -- error posting reverts to the &quot;permanent&quot; setting for the next message or bundle. -2 turn on locally in the bundle. These &quot;temporary&quot; states accumulate within a single bundle -- so if you have nested calls to methods that use bundle-local error suppression, error posting remains off until all the layers have been unwrapped. If you use ['/error', -1] within a self-bundling method, you should always close it with ['/error', -2] so that subsequent bundled messages will take the correct error posting status. However, even if this is not done, the next bundle or message received will begin with the standard error posting status, as set by modes 0 or 1. Temporary error suppression may not affect asynchronous commands in every case.","ref":"SuperCollider.SoundServer.Command.html#error/2","title":"SuperCollider.SoundServer.Command.error/2","type":"function"},{"doc":"","ref":"SuperCollider.SoundServer.Command.html#free_node/2","title":"SuperCollider.SoundServer.Command.free_node/2","type":"function"},{"doc":"Free all synths in this group and all its sub-groups. Traverses all groups below this group and frees all the synths. Sub-groups are not freed. A list of groups may be specified.","ref":"SuperCollider.SoundServer.Command.html#g_deep_free/2","title":"SuperCollider.SoundServer.Command.g_deep_free/2","type":"function"},{"doc":"Post a representation of this group's node subtree. Posts a representation of this group's node subtree, i.e. all the groups and synths contained within it, optionally including the current control values for synths. For the flag code: if not 0 the current control (arg) values for synths will be posted.","ref":"SuperCollider.SoundServer.Command.html#g_dump_tree/3","title":"SuperCollider.SoundServer.Command.g_dump_tree/3","type":"function"},{"doc":"Frees all nodes in the group. A list of groups may be specified.","ref":"SuperCollider.SoundServer.Command.html#g_free_all/2","title":"SuperCollider.SoundServer.Command.g_free_all/2","type":"function"},{"doc":"Adds the node to the head (first to be executed) of the group.","ref":"SuperCollider.SoundServer.Command.html#g_head/4","title":"SuperCollider.SoundServer.Command.g_head/4","type":"function"},{"doc":"Create a new group.","ref":"SuperCollider.SoundServer.Command.html#g_new/4","title":"SuperCollider.SoundServer.Command.g_new/4","type":"function"},{"doc":"Get a representation of this group's node subtree. Request a representation of this group's node subtree, i.e. all the groups and synths contained within it. Replies to the sender with a /g_queryTree.reply message listing all of the nodes contained within the group in the following format: https://doc.sccode.org/Reference/Server-Command-Reference.html#/g_queryTree","ref":"SuperCollider.SoundServer.Command.html#g_query_tree/3","title":"SuperCollider.SoundServer.Command.g_query_tree/3","type":"function"},{"doc":"Adds the node to the tail (last to be executed) of the group.","ref":"SuperCollider.SoundServer.Command.html#g_tail/4","title":"SuperCollider.SoundServer.Command.g_tail/4","type":"function"},{"doc":"Place a node after another. Places node A in the same group as node B, to execute immediately after node B.","ref":"SuperCollider.SoundServer.Command.html#n_after/3","title":"SuperCollider.SoundServer.Command.n_after/3","type":"function"},{"doc":"Place a node before another. Places node A in the same group as node B, to execute immediately before node B.","ref":"SuperCollider.SoundServer.Command.html#n_before/3","title":"SuperCollider.SoundServer.Command.n_before/3","type":"function"},{"doc":"Fill ranges of a node's control value(s). Set contiguous ranges of control indices to single values. For each range, the starting control index is given followed by the number of controls to change, followed by the value to fill. If the node is a group, then it sets the controls of every node in the group.","ref":"SuperCollider.SoundServer.Command.html#n_fill/3","title":"SuperCollider.SoundServer.Command.n_fill/3","type":"function"},{"doc":"Deletes a node. There is is also an alias to this function called free_node/2. From the SuperCollider docs: Stops a node abruptly, removes it from its group, and frees its memory. A list of node IDs may be specified. Using this method can cause a click if the node is not silent at the time it is freed. Takes the node id (integer) to delete as the second parameter.","ref":"SuperCollider.SoundServer.Command.html#n_free/2","title":"SuperCollider.SoundServer.Command.n_free/2","type":"function"},{"doc":"Map a node's controls to read from a bus. Takes a list of pairs of control names or indices and bus indices and causes those controls to be read continuously from a global control bus. If the node is a group, then it maps the controls of every node in the group. If the control bus index is -1 then any current mapping is undone. Any n_set, n_setn and n_fill command will also unmap the control.","ref":"SuperCollider.SoundServer.Command.html#n_map/3","title":"SuperCollider.SoundServer.Command.n_map/3","type":"function"},{"doc":"Map a node's controls to read from an audio bus. Takes a list of pairs of control names or indices and audio bus indices and causes those controls to be read continuously from a global audio bus. If the node is a group, then it maps the controls of every node in the group. If the audio bus index is -1 then any current mapping is undone. Any n_set, n_setn and n_fill command will also unmap the control. For the full audio rate signal, the argument must have its rate set to \\ar.","ref":"SuperCollider.SoundServer.Command.html#n_mapa/3","title":"SuperCollider.SoundServer.Command.n_mapa/3","type":"function"},{"doc":"Map a node's controls to read from audio buses. Takes a list of triplets of control names or indices, audio bus indices, and number of controls to map and causes those controls to be mapped sequentially to buses. If the node is a group, then it maps the controls of every node in the group. If the audio bus index is -1 then any current mapping is undone. Any n_set, n_setn and n_fill command will also unmap the control. For the full audio rate signal, the argument must have its rate set to \\ar.","ref":"SuperCollider.SoundServer.Command.html#n_mapan/3","title":"SuperCollider.SoundServer.Command.n_mapan/3","type":"function"},{"doc":"Map a node's controls to read from buses. Takes a list of triplets of control names or indices, bus indices, and number of controls to map and causes those controls to be mapped sequentially to buses. If the node is a group, then it maps the controls of every node in the group. If the control bus index is -1 then any current mapping is undone. Any n_set, n_setn and n_fill command will also unmap the control.","ref":"SuperCollider.SoundServer.Command.html#n_mapn/3","title":"SuperCollider.SoundServer.Command.n_mapn/3","type":"function"},{"doc":"Move and order a list of nodes. Moves the listed nodes to the location specified by the target and add action, and place them in the order specified. Nodes which have already been freed will be ignored. The second, third and fourth parameters are: int add action (0,1,2 or 3 see below) int add target ID N * int node IDs add actions are as follows: 0 construct the node order at the head of the group specified by the add target ID. 1 construct the node order at the tail of the group specified by the add target ID. 2 construct the node order just before the node specified by the add target ID. 3 construct the node order just after the node specified by the add target ID.","ref":"SuperCollider.SoundServer.Command.html#n_order/4","title":"SuperCollider.SoundServer.Command.n_order/4","type":"function"},{"doc":"Get info about a node. The server sends an /n_info message for each node to registered clients. See Node Notifications below for the format of the /n_info message.","ref":"SuperCollider.SoundServer.Command.html#n_query/2","title":"SuperCollider.SoundServer.Command.n_query/2","type":"function"},{"doc":"Turns a node on or off. Takes a node id (integer) as the second parameter and a run flag (integer) as the third. If the run flag set: to zero then the node will not be executed. back to one, then it will be executed. Note that using this method to start and stop nodes can cause a click if the node is not silent at the time run flag is toggled.","ref":"SuperCollider.SoundServer.Command.html#n_run/3","title":"SuperCollider.SoundServer.Command.n_run/3","type":"function"},{"doc":"Set a node's control value(s). If the node is a group, then it sets the controls of every node in the group. The second parameter is the node id (integer). The third parameter takes a list of pairs of control indices and values and sets the controls to those values. This message supports array type tags ($[ and $]) in the control/value component of the OSC message. Arrayed control values are applied in the manner of n_setn (i.e., sequentially starting at the indexed or named control).","ref":"SuperCollider.SoundServer.Command.html#n_set/3","title":"SuperCollider.SoundServer.Command.n_set/3","type":"function"},{"doc":"Set ranges of a node's control value(s). From the SuperCollider documentation: Set contiguous ranges of control indices to sets of values. For each range, the starting control index is given followed by the number of controls to change, followed by the values. If the node is a group, then it sets the controls of every node in the group. Takes a node id (integer) as it's second parameter.","ref":"SuperCollider.SoundServer.Command.html#n_setn/3","title":"SuperCollider.SoundServer.Command.n_setn/3","type":"function"},{"doc":"Trace a node. Causes a synth to print out the values of the inputs and outputs of its unit generators for one control period. Causes a group to print the node IDs and names of each node in the group for one control period.","ref":"SuperCollider.SoundServer.Command.html#n_trace/2","title":"SuperCollider.SoundServer.Command.n_trace/2","type":"function"},{"doc":"Register to receive notifications from scserver. Takes two optional parameters: flag: this is an integer with either: 1 to receive notifications (default): the server will remember your return address and send you notifications 0 to stop receiving them: scserver will stop sending notifications. client_id: an integer representing the client. This is optional. From SuperCollider documentation: Replies to sender with /done /notify clientID [maxLogins] when complete. If this client has registered for notifications before, this may be the same ID. Otherwise it will be a new one. Clients can use this ID in multi-client situations to avoid conflicts when allocating resources such as node IDs, bus indices, and buffer numbers. maxLogins is only returned when the client ID argument is supplied in this command. maxLogins is not supported by supernova.","ref":"SuperCollider.SoundServer.Command.html#notify/3","title":"SuperCollider.SoundServer.Command.notify/3","type":"function"},{"doc":"Create a new parallel group.","ref":"SuperCollider.SoundServer.Command.html#p_new/4","title":"SuperCollider.SoundServer.Command.p_new/4","type":"function"},{"doc":"Instructs scsynth to quit. Before exiting, scserver will reply to the sender with '/done'.","ref":"SuperCollider.SoundServer.Command.html#quit/1","title":"SuperCollider.SoundServer.Command.quit/1","type":"function"},{"doc":"Get control value(s). Second parameter is the synth id (integer). The third parameter is the control identifier, which can either be an integer id or a string name. Replies to sender with the corresponding /n_set command.","ref":"SuperCollider.SoundServer.Command.html#s_get/3","title":"SuperCollider.SoundServer.Command.s_get/3","type":"function"},{"doc":"Get ranges of control value(s). Get contiguous ranges of controls. Replies to sender with the corresponding /n_setn command.","ref":"SuperCollider.SoundServer.Command.html#s_getn/3","title":"SuperCollider.SoundServer.Command.s_getn/3","type":"function"},{"doc":"Create a new synth. Create a new synth from a synth definition, give it an ID, and add it to the tree of nodes. There are four ways to add the node to the tree as determined by the add action argument which is defined as follows: Parameters: string synth definition name int synth ID int add action (0,1,2, 3 or 4 see below) int add target ID N * int or string a control index or name float or int or string floating point and integer arguments are interpreted as control value. a symbol argument consisting of the letter 'c' or 'a' (for control or audio) followed by the bus's index. add actions: 0 add the new node to the head of the group specified by the add target ID. 1 add the new node to the tail of the group specified by the add target ID. 2 add the new node just before the node specified by the add target ID. 3 add the new node just after the node specified by the add target ID. 4 the new node replaces the node specified by the add target ID. The target node is freed. Controls may be set when creating the synth. The control arguments are the same as for the n_set command. If you send /s_new with a synth ID of -1, then the server will generate an ID for you. The server reserves all negative IDs. Since you don't know what the ID is, you cannot talk to this node directly later. So this is useful for nodes that are of finite duration and that get the control information they need from arguments and buses or messages directed to their group. In addition no notifications are sent when there are changes of state for this node, such as /go, /end, /on, /off. If you use a node ID of -1 for any other command, such as /n_map, then it refers to the most recently created node by /s_new (auto generated ID or not). This is how you can map the controls of a node with an auto generated ID. In a multi-client situation, the only way you can be sure what node -1 refers to is to put the messages in a bundle. This message now supports array type tags ($[ and $]) in the control/value component of the OSC message. Arrayed control values are applied in the manner of n_setn (i.e., sequentially starting at the indexed or named control). See the Node Messaging helpfile: https://doc.sccode.org/Guides/NodeMessaging.html","ref":"SuperCollider.SoundServer.Command.html#s_new/6","title":"SuperCollider.SoundServer.Command.s_new/6","type":"function"},{"doc":"Auto-reassign synth's ID to a reserved value. This command is used when the client no longer needs to communicate with the synth and wants to have the freedom to reuse the ID. The server will reassign this synth to a reserved negative number. This command is purely for bookkeeping convenience of the client. No notification is sent when this occurs.","ref":"SuperCollider.SoundServer.Command.html#s_noid/2","title":"SuperCollider.SoundServer.Command.s_noid/2","type":"function"},{"doc":"The primary way to send commands to a scynth sound server. For a given %SoundServer{} , takes an adress an optional arguments, encodes them as OSC and sends them to the sound server via UDP. This function makes use of the encode_osc/3 and send_to_sc/2 helper functions.","ref":"SuperCollider.SoundServer.Command.html#send_osc/3","title":"SuperCollider.SoundServer.Command.send_osc/3","type":"function"},{"doc":"Sends an encoded OSC message to the specified %SoundServer{} via UDP. Mainly used by send_osc/3 as a helper function.","ref":"SuperCollider.SoundServer.Command.html#send_to_sc/2","title":"SuperCollider.SoundServer.Command.send_to_sc/2","type":"function"},{"doc":"Query the servers status. Replies to sender with an '/status.reply' message with a list containing the following: int 1. unused. int number of unit generators. int number of synths. int number of groups. int number of loaded synth definitions. float average percent CPU usage for signal processing float peak percent CPU usage for signal processing double nominal sample rate double actual sample rate","ref":"SuperCollider.SoundServer.Command.html#status/1","title":"SuperCollider.SoundServer.Command.status/1","type":"function"},{"doc":"Notify when async commands have completed. Takes an unique integer identifying this command as the second parameter. Replies with a /synced message when all asynchronous commands received before this one have completed. The reply will contain the sent unique ID.","ref":"SuperCollider.SoundServer.Command.html#sync/2","title":"SuperCollider.SoundServer.Command.sync/2","type":"function"},{"doc":"","ref":"SuperCollider.SoundServer.Command.html#synth/2","title":"SuperCollider.SoundServer.Command.synth/2","type":"function"},{"doc":"","ref":"SuperCollider.SoundServer.Command.html#tone/1","title":"SuperCollider.SoundServer.Command.tone/1","type":"function"},{"doc":"Send a command to a unit generator. Sends all arguments following the command name to the unit generator to be performed. Commands are defined by unit generator plug ins.","ref":"SuperCollider.SoundServer.Command.html#u_cmd/5","title":"SuperCollider.SoundServer.Command.u_cmd/5","type":"function"},{"doc":"Query the SuperCollider version. Replies to sender with the following message: string Program name. May be &quot;scsynth&quot; or &quot;supernova&quot;. int Major version number. Equivalent to sclang's Main.scVersionMajor. int Minor version number. Equivalent to sclang's Main.scVersionMinor. string Patch version name. Equivalent to the sclang code &quot;.&quot; ++ Main.scVersionPatch ++ Main.scVersionTweak. string Git branch name. string First seven hex digits of the commit hash.","ref":"SuperCollider.SoundServer.Command.html#version/1","title":"SuperCollider.SoundServer.Command.version/1","type":"function"},{"doc":"This module is used to process OSC response messages sent from the SuperCollider. Currently, the following message types are supported: /version.reply (the server will send this OSC response after the SuperCollider.command(:version) command is issued) /status.reply (the server will send this OSC response after the SuperCollider.command(:status) command is issued) /fail (the server will send this OSC response when a command fails, such as freeing a node that doesn't exist SuperCollider.command(:n_free, 800) ) /done /synced Server responses are logged using Elixir's logger. Version, status and fail messages are added to the SoundServer's state under the response key, e.g.: % SuperCollider.SoundServer { ip : &#39;127.0.0.1&#39; , hostname : &#39;localhost&#39; , port : 57110 , socket : # Port &lt; 0.5 &gt; , responses : %{ fail : [ &quot;/n_free&quot; , &quot;Node 100 not found&quot; ] , status : [ { &quot;unused&quot; , 1 } , { &quot;number of unit generators&quot; , 0 } , { &quot;number of synths&quot; , 0 } , { &quot;number of groups&quot; , 2 } , { &quot;number of loaded synth definitions&quot; , 109 } , { &quot;average percent CPU usage for signal processing&quot; , 0.022701745852828026 } , { &quot;peak percent CPU usage for signal processing&quot; , 0.08792437613010406 } , { &quot;nominal sample rate&quot; , 44100.0 } , { &quot;actual sample rate&quot; , 44100.008983920634 } ] , version : [ { &quot;Program name. May be &quot; scsynth &quot; or &quot; supernova &quot;.&quot; , &quot;scsynth&quot; } , { &quot;Major version number. Equivalent to sclang&#39;s Main.scVersionMajor.&quot; , 3 } , { &quot;Minor version number. Equivalent to sclang&#39;s Main.scVersionMinor.&quot; , 13 } , { &quot;Patch version name. Equivalent to the sclang code &quot; . &quot; ++ Main.scVersionPatch ++ Main.scVersionTweak.&quot; , &quot;.0&quot; } , { &quot;Git branch name.&quot; , &quot;Version-3.13.0&quot; } , { &quot;First seven hex digits of the commit hash.&quot; , &quot;3188503&quot; } ] } } For convenience, you can quickly access these reponse messages by calling SuperCollider.response() or SuperCollider.response(key) where key is :version , :status or :fail .","ref":"SuperCollider.SoundServer.Response.html","title":"SuperCollider.SoundServer.Response","type":"module"},{"doc":"Handles SuperColliders OSC response message types. This is called from the SoundServer handle_info function, when it recieves OSC messages. Accepts a %SoundServer{} as the first parameter and the OSC response message as the second. For Version and Status response messages, additional text labels are added to the values returned in the form of a tuple: {&quot;label&quot;, value} . For example, an exert of the enrished version response is below: [ { &quot;Program name. May be &quot; scsynth &quot; or &quot; supernova &quot;.&quot; , &quot;scsynth&quot; } , { &quot;Major version number. Equivalent to sclang&#39;s Main.scVersionMajor.&quot; , 3 } , { &quot;Minor version number. Equivalent to sclang&#39;s Main.scVersionMinor.&quot; , 13 } , { &quot;Patch version name. Equivalent to the sclang code &quot; . &quot; ++ Main.scVersionPatch ++ Main.scVersionTweak.&quot; , &quot;.0&quot; } , { &quot;Git branch name.&quot; , &quot;Version-3.13.0&quot; } , { &quot;First seven hex digits of the commit hash.&quot; , &quot;3188503&quot; } ]","ref":"SuperCollider.SoundServer.Response.html#process_osc_message/2","title":"SuperCollider.SoundServer.Response.process_osc_message/2","type":"function"},{"doc":"Helper functions to encode Elixir data types into the binary format used by SuperCollider.","ref":"SuperCollider.SynthDef.Encoder.html","title":"SuperCollider.SynthDef.Encoder","type":"module"},{"doc":"Takes an number and encodes it into SuperCollider's 8-bit integer format.","ref":"SuperCollider.SynthDef.Encoder.html#write_8/1","title":"SuperCollider.SynthDef.Encoder.write_8/1","type":"function"},{"doc":"Takes an number and encodes it into SuperCollider's 16-bit integer format.","ref":"SuperCollider.SynthDef.Encoder.html#write_16/1","title":"SuperCollider.SynthDef.Encoder.write_16/1","type":"function"},{"doc":"Takes an number and encodes it into SuperCollider's 32-bit integer format.","ref":"SuperCollider.SynthDef.Encoder.html#write_32/1","title":"SuperCollider.SynthDef.Encoder.write_32/1","type":"function"},{"doc":"Takes an number and encodes it into SuperCollider's 32-bit float format.","ref":"SuperCollider.SynthDef.Encoder.html#write_float/1","title":"SuperCollider.SynthDef.Encoder.write_float/1","type":"function"},{"doc":"Takes a list of numbers and encodes it into SuperCollider's 32-bit float array format.","ref":"SuperCollider.SynthDef.Encoder.html#write_floats/1","title":"SuperCollider.SynthDef.Encoder.write_floats/1","type":"function"},{"doc":"Takes a list of key-value pairs and encodes it into SuperCollider's dictionary format. In this function, the key-value pairs must be of the following types: key: is a string value: is a float.","ref":"SuperCollider.SynthDef.Encoder.html#write_name_float_pairs/1","title":"SuperCollider.SynthDef.Encoder.write_name_float_pairs/1","type":"function"},{"doc":"Takes a list of key-value pairs and encodes it into SuperCollider's dictionary format. In this function, the key-value pairs must be of the following types: key: is a string value: is an integer.","ref":"SuperCollider.SynthDef.Encoder.html#write_name_integer_pairs/1","title":"SuperCollider.SynthDef.Encoder.write_name_integer_pairs/1","type":"function"},{"doc":"Takes a string and encodes it into SuperCollider's pstring format.","ref":"SuperCollider.SynthDef.Encoder.html#write_pstring/1","title":"SuperCollider.SynthDef.Encoder.write_pstring/1","type":"function"},{"doc":"This is a helper function to parse values from a .scsyndef file.","ref":"SuperCollider.SynthDef.Parser.html","title":"SuperCollider.SynthDef.Parser","type":"module"},{"doc":"Helper function for parsing multiple big-float-32s in a sequence. binary: hold the binary data number: number of floats to parse in a sequenece Parsed floats are rounded to 3 decimal places. Returns a tuple with a list of the floats as the first element, and the remainder of the binary data as the second parameter, e.g.: {float_list, binary_data} .","ref":"SuperCollider.SynthDef.Parser.html#parse_floats/2","title":"SuperCollider.SynthDef.Parser.parse_floats/2","type":"function"},{"doc":"Helper function for parsing 16 bit integers. Returns a tuple with a 16-bit integer as the first element, and the remainder of the binary data as the second parameter, e.g.: {int_value, binary_data} .","ref":"SuperCollider.SynthDef.Parser.html#parse_integer_16/1","title":"SuperCollider.SynthDef.Parser.parse_integer_16/1","type":"function"},{"doc":"Helper function for parsing 32 bit integers. Returns a tuple with a 32-big integer as the first element, and the remainder of the binary data as the second parameter, e.g.: {int_value, binary_data} .","ref":"SuperCollider.SynthDef.Parser.html#parse_integer_32/1","title":"SuperCollider.SynthDef.Parser.parse_integer_32/1","type":"function"},{"doc":"Helper function for parsing multiple key-value pairs in a sequence, where the key is a string and the value is a a float. binary: hold the binary data number: number of key-float value pairs to parse in a sequenece. Returns a tuple with a list of the floats as the first element, and the remainder of the binary data as the second parameter, e.g.: {float_list, binary_data} .","ref":"SuperCollider.SynthDef.Parser.html#parse_name_float_pairs/2","title":"SuperCollider.SynthDef.Parser.parse_name_float_pairs/2","type":"function"},{"doc":"Helper function for parsing multiple key-value pairs in a sequence, where the key is a string and the value is an integer. binary: hold the binary data number: number of key-integer value pairs to parse in a sequenece. Returns a tuple with a list of the floats as the first element, and the remainder of the binary data as the second parameter, e.g.: {float_list, binary_data} .","ref":"SuperCollider.SynthDef.Parser.html#parse_name_integer_pairs/2","title":"SuperCollider.SynthDef.Parser.parse_name_integer_pairs/2","type":"function"},{"doc":"Helper function for parsing pstrings. A pstring is SuperColliders string format, which starts with a 8-bit integer holding the length of the string ( string_length ), followed by a binary of string_length with the string data. Returns a tuple with string as the first element, and the remainder of the binary data as the second parameter, e.g.: {int_value, binary_data} .","ref":"SuperCollider.SynthDef.Parser.html#parse_pstring/1","title":"SuperCollider.SynthDef.Parser.parse_pstring/1","type":"function"},{"doc":"A struct representing a .scsyndef file in Elixir and a module for parsing (decoding) and encoding (to binary) SuperCollider synthdef files. Currently only version 2 files are supported. As a struct, %ScFile{} contains the following: type_id : a string ( SCgf ) representing the SuperCollider file format file_version : currently set to 2 (version 2 is the only file format currently supported) synth_defs_count : an integer count of the number of synthdefs within the file. nil if empty synth_defs : a list of synth definitions. These will use the %SynthDef{} struct. Key functions in this module include: parse/1 : for parsing a .scsyndef file. This will read the file from disc and call the decode/1 function. decode/1 : for deconding a scsyndef binary into an %ScFile{} struct. encode/1 : for encoding one or more %SynthDef{} into the scsyndef binary format. Example alias SuperCollider.SynthDef.ScFile # Parse the scsyndef file sc_file = ScFile . parse ( &quot;/supercollider/ambient.scsyndef&quot; ) # returns the parsed file as a `%ScFile{}` struct See below for further examples.","ref":"SuperCollider.SynthDef.ScFile.html","title":"SuperCollider.SynthDef.ScFile","type":"module"},{"doc":"Decodes a scsyndef binary into an %ScFile{} struct. Example Read a .scsyndef file from disc and decode it: alias SuperCollider.SynthDef.ScFile filename = &quot;/supercollider/closedhat.scsyndef&quot; sc_file = File . read! ( filename ) |&gt; ScFile . decode ( ) Note: If decoding directly from a file, you can use the ScFile.parse(filename) instead.","ref":"SuperCollider.SynthDef.ScFile.html#decode/1","title":"SuperCollider.SynthDef.ScFile.decode/1","type":"function"},{"doc":"Encodes an %ScFile{} or %SynthDef{} structs into SuperCollider's scsyndef binary format. This can be used to either send as binary data to to scynth or supernova via the :d_recv command, or write as a file to disc .scsyndef file. Takes either of the following as the first parameter: an %ScFile{} and encodes it into a new scsyndef binary single %SynthDef{} and encodes it into a new scsyndef binary (converting it to a %ScFile{} first) list of %SynthDef{} and encodes them into a new scsyndef binary (converting it to a %ScFile{} first).","ref":"SuperCollider.SynthDef.ScFile.html#encode/1","title":"SuperCollider.SynthDef.ScFile.encode/1","type":"function"},{"doc":"Takes a a filename as as single parameter, which is a the filename (and path) of the .scsyndef file to parse. This currently parses SuperCollider version 2 file format only. Returns the populated %ScFile{} struct. You can access the individual synth definitions via the :synth_def key on the struct. Example alias SuperCollider.SynthDef.ScFile # Parse the scsyndef file sc_file = ScFile . parse ( &quot;/supercollider/ambient.scsyndef&quot; ) This returns the parsed file as a struct: % SuperCollider.SynthDef.ScFile { type_id : &quot;SCgf&quot; , file_version : 2 , synth_defs_count : 1 , synth_defs : [ # ... truncated, see below for example contents of the synth_defs key ] , varient_count : 0 , varient_specs_list : [ ] } ] } You can access the list of synth definitions using the synth_def key: sc_file . synth_defs Which will return [ % SuperCollider.SynthDef { name : &quot;ambient&quot; , constant_values_list : [ 0.2 ] , parameter_values_list : [ 0.0 ] , parameter_names_list : [ %{ parameter_index : 0 , parameter_name : &quot;out&quot; } ] , ugen_specs_list : [ % SuperCollider.SynthDef.UGen { class_name : &quot;Control&quot; , calculation_rate : 1 , special_index : 0 , input_specs_list : [ ] , output_specs_list : [ %{ _enum_count : 0 , calculation_rate : 1 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;BrownNoise&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ ] , output_specs_list : [ %{ _enum_count : 0 , calculation_rate : 2 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;BinaryOpUGen&quot; , calculation_rate : 2 , special_index : 2 , input_specs_list : [ %{ index : 1 , output_index : 0 , type : :ugen } , %{ index : 0 , type : :constant } ] , output_specs_list : [ %{ _enum_count : 0 , calculation_rate : 2 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;Out&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ %{ index : 0 , output_index : 0 , type : :ugen } , %{ index : 2 , output_index : 0 , type : :ugen } ] , output_specs_list : [ ] } ] , varient_specs_list : [ ] } ]","ref":"SuperCollider.SynthDef.ScFile.html#parse/1","title":"SuperCollider.SynthDef.ScFile.parse/1","type":"function"},{"doc":"","ref":"readme.html","title":"README","type":"extras"},{"doc":"This is an Elixir library for interacting with SuperCollider , an audio synthesis and composition platform. SuperCollider as a platform covers both client ( sclang programming language and scide editing environment) and server ( scynth or supernova ). This Elixir library deals exclusively with the latter, that is, interacting with either: scsynth : a real-time audio server with hundreds of unit generators (UGens) for audio analysis, synthesis, and processing supernova : an alternative server to scsynth with support for parallel DSP on multi-core processors.","ref":"readme.html#overview","title":"README - Overview","type":"extras"},{"doc":"Elixir is dynamic, functional, expressive and fun! Running on top of the Erlang virtual machine, you’ll find Elixir on embedded systems (see the Nerves project ) to large multi-node distributed systems and everything in between. Maybe you’ll use this for your next hardware synth project! Elixir also offers Livebook , which can be used as a flexible creative coding environment. If Elixir isn’t your thing, there are other libraries in other programming languages for interacting with SuperCollider, such as Overtone (Clojure) , Tidal (Haskell) , Sonic Pi (built with Ruby, Erlang and Elixir) , Sorceress (Rust) and a number in Python .","ref":"readme.html#why-elixir","title":"README - Why Elixir?","type":"extras"},{"doc":"This library is currently under active development and it’s API is likely to change.","ref":"readme.html#status","title":"README - Status","type":"extras"},{"doc":"This library consists of a number of modules, the main ones being: SuperCollider which allows you to quickly get going without needing to understand too much of this library’s architecture. SuperCollider.SynthDef which is an Elixir struct representation of SuperCollider’s synth definitions, built from networks of UGens (unit generators) which generate or process both audio and control signals. SuperCollider.SoundServer a GenServer which is used to create the main process for sending and listening to scsynth or supernova messages. Messages are sent using Open Sound Control (OSC) protocol via UDP.","ref":"readme.html#architecture","title":"README - Architecture","type":"extras"},{"doc":"Below shows some basic examples of: starting SuperCollider sending commands loading and decoding .scsyndef files encoding a SynthDef struct to binary format sending the encoded SynthDef to scsynth or supernova. alias SuperCollider alias SuperCollider.SynthDef # Start the SoundServer. If scynth or supernova isn’t loaded, it will attempt to boot it. SuperCollider . start ( ) # Get the status from scynth or supernova SuperCollider . command ( :status ) # The response to some commands, such as :status, is stored in the SuperCollider&#39;s GenServer state. You can access that response anytime as below: SuperCollider . response [ :status ] # This reurns the status in a list of Tuples like this: # [ # {&quot;unused&quot;, 1}, # {&quot;number of unit generators&quot;, 0}, # {&quot;number of synths&quot;, 0}, # {&quot;number of groups&quot;, 2}, # {&quot;number of loaded synth definitions&quot;, 109}, # {&quot;average percent CPU usage for signal processing&quot;, 0.022731395438313484}, # {&quot;peak percent CPU usage for signal processing&quot;, 0.09797607362270355}, # {&quot;nominal sample rate&quot;, 44100.0}, # {&quot;actual sample rate&quot;, 44099.97439210702} # ] # Send a command to play a basic 300Hz sinusoidal sound on node 100 # This assumes the sine SynthGen is installed on the server SuperCollider . command ( :s_new , [ &quot;sine&quot; , 100 , 1 , 1 , [ &quot;freq&quot; , 300 ] ] ) # Stop the sound by freeing node 100 SuperCollider . command ( :n_free , 100 ) # Decode a .scsyndef file into an %SynthDef{} struct closed_hat = SynthDef . from_file ( &quot;closed_hat.scsyndef&quot; ) # Encode a SynthDef to binary format, which is used by scsynth or supernova encoded_data = SynthDef . to_binary ( closed_hat ) # Send the encoded SynthDef to scynth or supernova SuperCollider . command ( :d_recv , encoded_data )","ref":"readme.html#example","title":"README - Example","type":"extras"},{"doc":"Installation of SuperCollider You’ll need to have SuperCollider installed. See SuperCollider’s downloads page for supported platforms. Currently there are Mac, Linux, Windows builds. It can be built on embedded platforms, including Raspberry Pi , Beagle Bone Black and Bela . Adding it to your Elixir project The package can be installed by adding supercollider to your list of dependencies in mix.exs : def deps do [ { :supercollider , &quot;~&gt; 0.1.4&quot; } ] end Using within LiveBook and IEx Mix . install ( [ { :supercollider , &quot;~&gt; 0.1.4&quot; } ] ) Also see the interactive tour in LiveBook at /livebook/supercollider_tour.livemd .","ref":"readme.html#getting-started","title":"README - Getting started","type":"extras"},{"doc":"The docs can be found at https://hexdocs.pm/supercollider .","ref":"readme.html#documentation","title":"README - Documentation","type":"extras"},{"doc":"Mix . install ( [ # :supercollider { :supercollider , github : &quot;haubie/supercollider&quot; } ] ) * Getting supercollider ( https :// github . com / haubie / supercollider . git ) remote : Enumerating objects : 315 , done . remote : Counting objects : 100 % ( 315 / 315 ) , done . remote : Compressing objects : 100 % ( 201 / 201 ) , done . remote : Total 315 ( delta 119 ) , reused 299 ( delta 103 ) , pack - reused 0 origin / HEAD set to main Resolving Hex dependencies ... Resolution completed in 0.01 s New : osc 0.1 . 2 * Getting osc ( Hex package ) warning : variable &quot;deps&quot; does not exist and is being expanded to &quot;deps()&quot; , please use parentheses to remove the ambiguity or change the variable name / Users / haubie / Library / Caches / mix / installs / elixir - 1.14 . 3 - erts - 13.1 . 4 / 65 dc787146a7b8fb892473272c6ebd40 / deps / osc / mix . exs : 11 : Osc.Mixfile . project / 0 warning : variable &quot;package&quot; does not exist and is being expanded to &quot;package()&quot; , please use parentheses to remove the ambiguity or change the variable name / Users / haubie / Library / Caches / mix / installs / elixir - 1.14 . 3 - erts - 13.1 . 4 / 65 dc787146a7b8fb892473272c6ebd40 / deps / osc / mix . exs : 12 : Osc.Mixfile . project / 0 == &gt; osc Compiling 13 files ( . ex ) warning : incompatible types : float ( ) ! ~ integer ( ) in expression : # lib/osc/integer.ex:5 &lt;&lt; integer :: integer - big - size ( 32 ) &gt;&gt; where &quot;integer&quot; was given the type integer ( ) | float ( ) in : # lib/osc/integer.ex:4 abs ( integer ) where &quot;integer&quot; was given the type integer ( ) in : # lib/osc/integer.ex:5 &lt;&lt; integer :: integer - big - size ( 32 ) &gt;&gt; Conflict found at lib / osc / integer . ex : 5 : OSC.Encoder.Integer . encode / 2 warning : incompatible types : float ( ) ! ~ integer ( ) in expression : # lib/osc/integer.ex:5 &lt;&lt; integer :: integer - big - size ( 64 ) &gt;&gt; where &quot;integer&quot; was given the type integer ( ) | float ( ) in : # lib/osc/integer.ex:4 abs ( integer ) where &quot;integer&quot; was given the type integer ( ) in : # lib/osc/integer.ex:5 &lt;&lt; integer :: integer - big - size ( 64 ) &gt;&gt; Conflict found at lib / osc / integer . ex : 5 : OSC.Encoder.Integer . encode / 2 Generated osc app == &gt; supercollider Compiling 9 files ( . ex ) Generated supercollider app :ok","ref":"supercollider_tour.html","title":"SuperCollider tour","type":"extras"},{"doc":"This is an Elixir library for interacting with SuperCollider , an audio synthesis and composition platform. Using a simple client-server architecture, this library works through Open Sound Control (OSC) messages sent via UDP to and from SuperCollider's audio server (called: scynth or supernova depending on which varient you're using). sequenceDiagram participant SuperCollider.SoundServer participant scsynth SuperCollider.SoundServer-&gt;&gt;scsynth: OSC command scsynth--&gt;&gt;SuperCollider.SoundServer: OSC response By default, this library expects scynth or supernova to be installed locally and available via localhost (although this is configurable).","ref":"supercollider_tour.html#introduction","title":"SuperCollider tour - Introduction","type":"extras"},{"doc":"Install SuperCollider You’ll need to have SuperCollider installed. See SuperCollider’s downloads page for supported platforms. Currently there are Mac, Linux, Windows builds. It can be built on embedded platforms, including Raspberry Pi , Beagle Bone Black and Bela . Once you have it installed, you should be able to continue with the examples in the livebook. SuperCollider concepts If you're new to SuperCollider, there are some foundational concepts you'll need to be aware of. The most important of these are UGen and SynthDef . UGen (Unit generator) UGens process or generate sound and control signals. UGens can be thought of as 'calculations with signals'. UGens can have many inputs, but always have a single output. They are the basic building blocks of synth definitions. To play a UGen, it needs to be compiled in a SynthDef and played on the server in a Synth. There are UGens that come with SuperCollider , or you can download the many community contributed UGens . For a demonstration in SuperCollider's language (sclang), watch the Supercollider Concepts - Ugens video. SynthDef (Synth definition) SynthDefs describe how different UGens will be patched together to create sounds. SynthDefs are like the presets on commercial hardware and software synthesizers. SynthDefs are a graph-like data-structure of UGens. SynthDefs are used to create synth nodes on the SuperCollider's server (a synth node is a container for one or more unit generators that execute together). SynthDefs are a template or recipe, upon which Synths are be based. SynthDefs can be saved into a binary file format ( .scsyndef ) and loaded by SuperCollider's server. For a demonstration in SuperCollider's language (sclang), watch the SuperCollider Tutorial: 3. Synth and SynthDef video. Synth and synth node A Synth represents a single sound producing unit. What it does is defined in a SynthDef, including what inputs and outputs the Synth will have. On the client side, we create a synth through SuperCollider.command(:s_new, opts) , which will send the message to SuperCollider's server to create a new synth from a synth definition. On the server (scsynth or supernova) synth nodes are created, which is a container representing your synth on the server. Nodes on the server have an integer node id . We can communicate to nodes from the client using this id, e.g. SuperCollider.command(:n_free, 100) will free node 100. You can learn more about these concepts and more through one of the many introductory tutorials . Expanding SuperCollider As UGens are the base component on the server for creating sounds, you may wish to expand the number you have installed on the SuperCollider server. One of the popular community collections of UGens is: http://supercollider.github.io/sc3-plugins/ If you'd like to get familiar with the UGens pre-bundled with SuperCollider, see Tour of UGens or browse https://doc.sccode.org/Browse.html#UGens","ref":"supercollider_tour.html#getting-started","title":"SuperCollider tour - Getting started","type":"extras"},{"doc":"The simplest way to get going with this library is to call the SuperCollider.start/1 function. This does a number of things: Starts an instance of SuperCollider.SoundServer , which is an Elixir GenServer Checks if SuperCollider's scynth (or supernova) audio servers are booted locally, and if not, it will try and load it in the typical file location for your platform Stores the PID of the SuperCollider.SoundServer in a globally available persistient term, so you don't have to remember to pass it around when using the top-level functions under the SuperCollider module. SuperCollider . start ( ) INIT : % SuperCollider.SoundServer { ip : &#39;127.0.0.1&#39; , hostname : &#39;localhost&#39; , port : 57110 , socket : nil , type : :scsynth , responses : %{ } } 16 : 24 : 52.526 [ info ] scsynth - waiting up to 5 seconds to see if already loaded ⏳ 16 : 24 : 52.537 [ info ] scsynth - already booted ✅ # PID &lt; 0 . 522 . 0 &gt; By default, it will look for scsynth . If you prefer to use supernova you can pass the type option instead: SuperCollider . start ( type : :supernova )","ref":"supercollider_tour.html#starting-the-elixir-supercollider-library","title":"SuperCollider tour - Starting the Elixir SuperCollider library","type":"extras"},{"doc":"Sending commands To comminicate from Elixir to SuperCollider's audio server (scsynth or supernova), we need to send it commands. We can do that through the SuperCollider.command/1 or SuperCollider.command/2 top-level functions. Let's start with two very simple commands to get the server's version information and it's current status. SuperCollider . command ( :version ) :ok 16 : 24 : 58.238 [ info ] Version : [ { &quot;Program name. May be \\&quot; scsynth \\&quot; or \\&quot; supernova \\&quot; .&quot; , &quot;scsynth&quot; } , { &quot;Major version number. Equivalent to sclang&#39;s Main.scVersionMajor.&quot; , 3 } , { &quot;Minor version number. Equivalent to sclang&#39;s Main.scVersionMinor.&quot; , 13 } , { &quot;Patch version name. Equivalent to the sclang code \\&quot; . \\&quot; ++ Main.scVersionPatch ++ Main.scVersionTweak.&quot; , &quot;.0&quot; } , { &quot;Git branch name.&quot; , &quot;Version-3.13.0&quot; } , { &quot;First seven hex digits of the commit hash.&quot; , &quot;3188503&quot; } ] SuperCollider . command ( :status ) :ok 16 : 25 : 00.316 [ info ] Status : [ { &quot;unused&quot; , 1 } , { &quot;number of unit generators&quot; , 0 } , { &quot;number of synths&quot; , 0 } , { &quot;number of groups&quot; , 2 } , { &quot;number of loaded synth definitions&quot; , 110 } , { &quot;average percent CPU usage for signal processing&quot; , 0.027132486924529076 } , { &quot;peak percent CPU usage for signal processing&quot; , 0.09582275152206421 } , { &quot;nominal sample rate&quot; , 44100.0 } , { &quot;actual sample rate&quot; , 44099.94790589288 } ] Accessing server responses Assuming it worked for you, these functions return an :ok atom after the command has been issued. Logging will show the message recieved from the SuperCollider's server, but what if you'd like to access it and process these messages in code? For that, we need to access the SuperCollider.SoundServer state, which holds messages recieved from SuperCollider. We can use the top-level functions of SuperCollider.response/0 or SuperCollider.response/1 for that. # You can fetch responses from the server using the response function: SuperCollider . response ( ) %{ status : [ { &quot;unused&quot; , 1 } , { &quot;number of unit generators&quot; , 0 } , { &quot;number of synths&quot; , 0 } , { &quot;number of groups&quot; , 2 } , { &quot;number of loaded synth definitions&quot; , 110 } , { &quot;average percent CPU usage for signal processing&quot; , 0.027132486924529076 } , { &quot;peak percent CPU usage for signal processing&quot; , 0.09582275152206421 } , { &quot;nominal sample rate&quot; , 44100.0 } , { &quot;actual sample rate&quot; , 44099.94790589288 } ] , version : [ { &quot;Program name. May be \\&quot; scsynth \\&quot; or \\&quot; supernova \\&quot; .&quot; , &quot;scsynth&quot; } , { &quot;Major version number. Equivalent to sclang&#39;s Main.scVersionMajor.&quot; , 3 } , { &quot;Minor version number. Equivalent to sclang&#39;s Main.scVersionMinor.&quot; , 13 } , { &quot;Patch version name. Equivalent to the sclang code \\&quot; . \\&quot; ++ Main.scVersionPatch ++ Main.scVersionTweak.&quot; , &quot;.0&quot; } , { &quot;Git branch name.&quot; , &quot;Version-3.13.0&quot; } , { &quot;First seven hex digits of the commit hash.&quot; , &quot;3188503&quot; } ] } You can see from the response map, the :status and :version commands have their own key-value. We could fetch these in any of the usual Elixir-ish ways, but for convience, SuperCollider.response/1 accepts the key you'ld like to fetch as the first parameter. # Get the version response SuperCollider . response ( :version ) [ { &quot;Program name. May be \\&quot; scsynth \\&quot; or \\&quot; supernova \\&quot; .&quot; , &quot;scsynth&quot; } , { &quot;Major version number. Equivalent to sclang&#39;s Main.scVersionMajor.&quot; , 3 } , { &quot;Minor version number. Equivalent to sclang&#39;s Main.scVersionMinor.&quot; , 13 } , { &quot;Patch version name. Equivalent to the sclang code \\&quot; . \\&quot; ++ Main.scVersionPatch ++ Main.scVersionTweak.&quot; , &quot;.0&quot; } , { &quot;Git branch name.&quot; , &quot;Version-3.13.0&quot; } , { &quot;First seven hex digits of the commit hash.&quot; , &quot;3188503&quot; } ] # Get the status response SuperCollider . response ( :status ) [ { &quot;unused&quot; , 1 } , { &quot;number of unit generators&quot; , 0 } , { &quot;number of synths&quot; , 0 } , { &quot;number of groups&quot; , 2 } , { &quot;number of loaded synth definitions&quot; , 110 } , { &quot;average percent CPU usage for signal processing&quot; , 0.027132486924529076 } , { &quot;peak percent CPU usage for signal processing&quot; , 0.09582275152206421 } , { &quot;nominal sample rate&quot; , 44100.0 } , { &quot;actual sample rate&quot; , 44099.94790589288 } ] Summary So far, we've stepped though SuperCollider's client-server architecture in a basic way by: Starting the SuperCollider Sending commands Accessing responses. But what about making sounds?","ref":"supercollider_tour.html#basic-server-communication-get-server-version-and-status","title":"SuperCollider tour - Basic server communication: get server version and status","type":"extras"},{"doc":"Let's begin by defining a SynthDef. A SynthDef is our 'template' that describes how we'll patch different UGen's together to produce our sound. Let's adapt the a simple sine-oscilator from the SuperCollider getting started guide . The SynthDef writen in sclang looks like this: ( SynthDef . new ( &quot;tutorial-SinOsc-stereo&quot; , { | out | var outArray ; outArray = [ SinOsc . ar ( 440 , 0 , 0.2 ) , SinOsc . ar ( 442 , 0 , 0.2 ) ] ; Out . ar ( out , outArray ) } ) ) This SynthDef makes use of the following UGens: SinOsc which generates a sine wave Out which writes (plays out) the audio signal generated by SinOsc to a bus. The SynthGen equivalent in this Elxir library is more verbose. This is because the above is expanded into it's full graph-like data structure. As this library develops, a friendly and more compact DSL for creating SynthDefs will be explored to generate the SynthGen graph. # Let&#39;s alias our modules to make our SynthDef easier to read alias SuperCollider.SynthDef alias SuperCollider.SynthDef.UGen # Let&#39;s assign our SynthDef to `stereo_sine_example` so we can use it later on stereo_sine_example = % SynthDef { name : &quot;tutorial-SinOsc-stereo&quot; , constant_values_list : [ 440.0 , 0.0 , 0.2 , 442.0 ] , parameter_values_list : [ 0.0 ] , parameter_names_list : [ %{ parameter_index : 0 , parameter_name : &quot;out&quot; } ] , ugen_specs_list : [ % UGen { class_name : &quot;Control&quot; , calculation_rate : 1 , special_index : 0 , input_specs_list : [ ] , output_specs_list : [ %{ calculation_rate : 1 } ] } , % UGen { class_name : &quot;SinOsc&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ %{ index : 0 , type : :constant } , %{ index : 1 , type : :constant } ] , output_specs_list : [ %{ calculation_rate : 2 } ] } , % UGen { class_name : &quot;BinaryOpUGen&quot; , calculation_rate : 2 , special_index : 2 , input_specs_list : [ %{ index : 1 , output_index : 0 , type : :ugen } , %{ index : 2 , type : :constant } ] , output_specs_list : [ %{ calculation_rate : 2 } ] } , % UGen { class_name : &quot;SinOsc&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ %{ index : 3 , type : :constant } , %{ index : 1 , type : :constant } ] , output_specs_list : [ %{ calculation_rate : 2 } ] } , % UGen { class_name : &quot;BinaryOpUGen&quot; , calculation_rate : 2 , special_index : 2 , input_specs_list : [ %{ index : 3 , output_index : 0 , type : :ugen } , %{ index : 2 , type : :constant } ] , output_specs_list : [ %{ calculation_rate : 2 } ] } , % UGen { class_name : &quot;Out&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ %{ index : 0 , output_index : 0 , type : :ugen } , %{ index : 2 , output_index : 0 , type : :ugen } , %{ index : 4 , output_index : 0 , type : :ugen } ] , output_specs_list : [ ] } ] , varient_specs_list : [ ] } % SuperCollider.SynthDef { name : &quot;tutorial-SinOsc-stereo&quot; , constant_values_list : [ 440.0 , 0.0 , 0.2 , 442.0 ] , parameter_values_list : [ 0.0 ] , parameter_names_list : [ %{ parameter_index : 0 , parameter_name : &quot;out&quot; } ] , ugen_specs_list : [ % SuperCollider.SynthDef.UGen { class_name : &quot;Control&quot; , calculation_rate : 1 , special_index : 0 , input_specs_list : [ ] , output_specs_list : [ %{ calculation_rate : 1 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;SinOsc&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ %{ index : 0 , type : :constant } , %{ index : 1 , type : :constant } ] , output_specs_list : [ %{ calculation_rate : 2 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;BinaryOpUGen&quot; , calculation_rate : 2 , special_index : 2 , input_specs_list : [ %{ index : 1 , output_index : 0 , type : :ugen } , %{ index : 2 , type : :constant } ] , output_specs_list : [ %{ calculation_rate : 2 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;SinOsc&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ %{ index : 3 , type : :constant } , %{ index : 1 , type : :constant } ] , output_specs_list : [ %{ calculation_rate : 2 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;BinaryOpUGen&quot; , calculation_rate : 2 , special_index : 2 , input_specs_list : [ %{ index : 3 , output_index : 0 , type : :ugen } , %{ index : 2 , type : :constant } ] , output_specs_list : [ %{ calculation_rate : 2 } ] } , % SuperCollider.SynthDef.UGen { class_name : &quot;Out&quot; , calculation_rate : 2 , special_index : 0 , input_specs_list : [ %{ index : 0 , output_index : 0 , type : :ugen } , %{ index : 2 , output_index : 0 , type : :ugen } , %{ index : 4 , output_index : 0 , type : :ugen } ] , output_specs_list : [ ] } ] , varient_specs_list : [ ] } Let's unpack this example a bit more: SinOsc This example is a stereo example. It plays two different SinOsc, one on the left audio channel, the one on the right: The SinOsc with the frequency argument of 440 Hz will be played out on the first output bus (the left channel). The SinOsc with the frequency argument of 442 Hz will be played out on the second bus (the right channel). By default, out assumes bus 0 as the first channel, so the two will play on buses 0 and 1 respectively. So how does this happen? Out UGen The Out UGen in this example writes out a signal to the server's busses, which in this case is the audio output of the computer. The Out UGen takes two arguments, the: first is the index number of the bus to write out on. These start from 0, which on a stereo setup is usually the left output channel. second is either a UGen or an Array of UGens. If you provide an array (i.e. a multichannel output) then the first channel will be played out on the bus with the indicated index, the second channel on the bus with the indicated index + 1, and so on. So in this example, because we're patching two SinOsc to Out, the first will play on the left channel (bus 0), and the second will on the right channel (bus 1).","ref":"supercollider_tour.html#creating-a-synthdef","title":"SuperCollider tour - Creating a SynthDef","type":"extras"},{"doc":"The next step is to send it to SuperCollider's audio server (scsynth or supernova). To do this, our SynthGen struct first needs to be encoded into the binary format which SuperCollider accepts. Once in binary format, we can send it across to the server , ready to play! # Encode into binary format bin_data = SynthDef . to_binary ( stereo_sine_example ) &lt;&lt; 83 , 67 , 103 , 102 , 0 , 0 , 0 , 2 , 0 , 1 , 22 , 116 , 117 , 116 , 111 , 114 , 105 , 97 , 108 , 45 , 83 , 105 , 110 , 79 , 115 , 99 , 45 , 115 , 116 , 101 , 114 , 101 , 111 , 0 , 0 , 0 , 4 , 67 , 220 , 0 , 0 , 0 , 0 , 0 , 0 , 62 , 76 , 204 , 205 , 67 , ... &gt;&gt; Now that it has been encoded and assigned to bin_data , we can use SuperCollider's :d_recv command to send it to scynth or supernova. SuperCollider . command ( :d_recv , bin_data ) :ok 17 : 09 : 17.967 [ info ] / d_recv That's it! We've just: Defined our SynthDef in Elixir using the %SynthDef{} and %UGen{} structs Encoded into the binary format that SuperCollider audio servers use Sent it to SuperCollider's audio server (scsynth or supernova). We're now ready to play our new SynthDef!","ref":"supercollider_tour.html#sending-it-to-supercollider-s-server","title":"SuperCollider tour - Sending it to SuperCollider's server","type":"extras"},{"doc":"Now the &quot;tutorial-SinOsc-stereo&quot; SynthDef is on the audio server, we need to create (instantiate) a synth using the SynthDef by issuing the :s_new command. We'll add this to node 100 as we haven't use it yet. SuperCollider . command ( :s_new , [ &quot;tutorial-SinOsc-stereo&quot; , 100 , 1 , 0 , [ ] ] ) :ok You should now hear the two sine waves playing from each channel.","ref":"supercollider_tour.html#play-synthdef","title":"SuperCollider tour - Play SynthDef","type":"extras"},{"doc":"You may remember from the concepts section above, that SuperCollider creates a synth node on the server which is the container for the playing synth. When we issues the :s_new command we assigned a node ID of 100 to it. We can use this same ID to 'free' the node, which releases the synth node and stops it from playing. To do that, we send the :n_free command (free node) with the node number of 100 . SuperCollider . command ( :n_free , 100 ) :ok The sound will stop when the node is freed. To recap, we: Started SuperCollider Learned to send commands, like :version , :status , :d_recv , :s_new and :n_free Learned to access responses for commands like :version and :status using SuperCollider.response() Defined a %SynthGen{} called &quot;tutorial-SinOsc-stereo&quot;, made up of %UGens{} of SinOsc and Out Encoded it into SuperCollider's binary format Sent it to the audio server (scynth or supernova) Created and played a Synth on the server using the &quot;tutorial-SinOsc-stereo&quot; SynthGen on node 100 Stopped it by freeing node 100 using the :n_free command!","ref":"supercollider_tour.html#stop-the-synth-from-playing","title":"SuperCollider tour - Stop the synth from playing","type":"extras"},{"doc":"That ends our first tour! If you'd like to shutdown the audio server process (scsynth or supernova), you can send the :quit command. SuperCollider . command ( :quit ) :ok","ref":"supercollider_tour.html#shutting-down-the-supercollider-audio-server","title":"SuperCollider tour - Shutting down the SuperCollider audio server","type":"extras"},{"doc":"MIT License Copyright (c) 2023 David Haubenschild. Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License (MIT)","type":"extras"}]