sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"overview","id":"Overview"},{"anchor":"why-elixir","id":"Why Elixir?"},{"anchor":"status","id":"Status"},{"anchor":"architecture","id":"Architecture"},{"anchor":"example","id":"Example"},{"anchor":"getting-started","id":"Getting started"},{"anchor":"documentation","id":"Documentation"}],"id":"readme","title":"README"},{"group":"","headers":[{"anchor":"introduction","id":"Introduction"},{"anchor":"getting-started","id":"Getting started"},{"anchor":"starting-the-elixir-supercollider-library","id":"Starting the Elixir SuperCollider library"},{"anchor":"basic-server-communication-get-server-version-and-status","id":"Basic server communication: get server version and status"},{"anchor":"creating-a-synthdef","id":"Creating a SynthDef"},{"anchor":"sending-it-to-supercollider-s-server","id":"Sending it to SuperCollider's server"},{"anchor":"play-synthdef","id":"Play SynthDef"},{"anchor":"stop-the-synth-from-playing","id":"Stop the synth from playing"},{"anchor":"shutting-down-the-supercollider-audio-server","id":"Shutting down the SuperCollider audio server"}],"id":"supercollider_tour","title":"SuperCollider tour"},{"group":"","headers":[],"id":"license","title":"License (MIT)"}],"modules":[{"group":"","id":"SuperCollider","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"command/1","id":"command/1","title":"command(command_name)"},{"anchor":"command/2","id":"command/2","title":"command(command_name, args)"},{"anchor":"pid/0","id":"pid/0","title":"pid()"},{"anchor":"response/0","id":"response/0","title":"response()"},{"anchor":"response/1","id":"response/1","title":"response(key)"},{"anchor":"start/1","id":"start/1","title":"start(opts \\\\ [])"},{"anchor":"state/0","id":"state/0","title":"state()"}]}],"sections":[{"anchor":"module-example","id":"Example"}],"title":"SuperCollider"},{"group":"","id":"SuperCollider.SynthDef","nodeGroups":[{"key":"support-functions","name":"Support functions","nodes":[{"anchor":"decode/1","id":"decode/1","title":"decode(bin_data)"},{"anchor":"encode/1","id":"encode/1","title":"encode(synthdefs)"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"from_file/1","id":"from_file/1","title":"from_file(filename)"},{"anchor":"new/1","id":"new/1","title":"new(opts \\\\ [])"},{"anchor":"to_binary/1","id":"to_binary/1","title":"to_binary(synthdef)"}]}],"sections":[{"anchor":"module-example-create-a-synthdef-from-scratch","id":"Example - create a SynthDef from scratch"}],"title":"SuperCollider.SynthDef"},{"group":"","id":"SuperCollider.SynthDef.UGen","nodeGroups":[{"key":"support-functions","name":"Support functions","nodes":[{"anchor":"decode/1","id":"decode/1","title":"decode(arg)"},{"anchor":"encode/2","id":"encode/2","title":"encode(ugen_count, ugen_specs_list)"}]}],"sections":[],"title":"SuperCollider.SynthDef.UGen"},{"group":"Server","id":"SuperCollider.SoundServer","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"__struct__/0","id":"%SuperCollider.SoundServer{}","title":"%SuperCollider.SoundServer{}"},{"anchor":"child_spec/1","id":"child_spec/1","title":"child_spec(init_arg)"},{"anchor":"command/2","id":"command/2","title":"command(pid, command_name)"},{"anchor":"command/3","id":"command/3","title":"command(pid, command_name, args)"},{"anchor":"handle_info/2","id":"handle_info/2","title":"handle_info(msg, state)"},{"anchor":"init/1","id":"init/1","title":"init(soundserver \\\\ %__MODULE__{})"},{"anchor":"maybe_boot_scsynth/1","id":"maybe_boot_scsynth/1","title":"maybe_boot_scsynth(soundserver)"},{"anchor":"new/1","id":"new/1","title":"new(opts \\\\ [])"},{"anchor":"open/1","id":"open/1","title":"open(port_num \\\\ 0)"},{"anchor":"run/1","id":"run/1","title":"run(soundserver \\\\ %__MODULE__{})"},{"anchor":"scsynth_booted?/1","id":"scsynth_booted?/1","title":"scsynth_booted?(soundserver)"},{"anchor":"start_link/1","id":"start_link/1","title":"start_link(opts \\\\ [])"},{"anchor":"state/1","id":"state/1","title":"state(pid)"}]}],"sections":[{"anchor":"module-basic-configuration","id":"Basic configuration"},{"anchor":"module-starting-a-server","id":"Starting a server"},{"anchor":"module-requesting-the-server-s-status","id":"Requesting the server's status"},{"anchor":"module-play-a-sine-wave-ugen","id":"Play a sine wave UGen"}],"title":"SuperCollider.SoundServer"},{"group":"Server","id":"SuperCollider.SoundServer.Command","nodeGroups":[{"key":"osc-communication","name":"OSC communication","nodes":[{"anchor":"dump_osc/2","id":"dump_osc/2","title":"dump_osc(soundserver, code)"},{"anchor":"encode_osc/2","id":"encode_osc/2","title":"encode_osc(address, arguments \\\\ [])"},{"anchor":"send_osc/3","id":"send_osc/3","title":"send_osc(soundserver, address, arguments \\\\ [])"},{"anchor":"send_to_sc/2","id":"send_to_sc/2","title":"send_to_sc(soundserver, osc_message)"}]},{"key":"general-commands","name":"General commands","nodes":[{"anchor":"clear_sched/1","id":"clear_sched/1","title":"clear_sched(soundserver)"},{"anchor":"cmd/3","id":"cmd/3","title":"cmd(soundserver, command_name, arguments \\\\ [])"},{"anchor":"error/2","id":"error/2","title":"error(soundserver, mode)"},{"anchor":"notify/3","id":"notify/3","title":"notify(soundserver, flag \\\\ 1, client_id \\\\ nil)"},{"anchor":"quit/1","id":"quit/1","title":"quit(soundserver)"},{"anchor":"status/1","id":"status/1","title":"status(soundserver)"},{"anchor":"sync/2","id":"sync/2","title":"sync(soundserver, command_code)"},{"anchor":"version/1","id":"version/1","title":"version(soundserver)"}]},{"key":"synth-commands","name":"Synth commands","nodes":[{"anchor":"d_free/2","id":"d_free/2","title":"d_free(soundserver, synth_def_name)"},{"anchor":"d_load/3","id":"d_load/3","title":"d_load(soundserver, path, completion_message \\\\ nil)"},{"anchor":"d_load_dir/3","id":"d_load_dir/3","title":"d_load_dir(soundserver, path, completion_message \\\\ nil)"},{"anchor":"d_recv/3","id":"d_recv/3","title":"d_recv(soundserver, data, completion_message \\\\ nil)"},{"anchor":"s_get/3","id":"s_get/3","title":"s_get(soundserver, synth_id, control_name)"},{"anchor":"s_getn/3","id":"s_getn/3","title":"s_getn(soundserver, synth_id, control_name)"},{"anchor":"s_new/6","id":"s_new/6","title":"s_new(soundserver, synth_def_name, synth_id, add_action_code, add_target_id, control_args \\\\ [])"},{"anchor":"s_noid/2","id":"s_noid/2","title":"s_noid(soundserver, synth_ids)"}]},{"key":"node-commands","name":"Node commands","nodes":[{"anchor":"n_after/3","id":"n_after/3","title":"n_after(soundserver, node_a_id, node_b_id)"},{"anchor":"n_before/3","id":"n_before/3","title":"n_before(soundserver, node_a_id, node_b_id)"},{"anchor":"n_fill/3","id":"n_fill/3","title":"n_fill(soundserver, node_id, args \\\\ [])"},{"anchor":"n_free/2","id":"n_free/2","title":"n_free(soundserver, node_id)"},{"anchor":"n_map/3","id":"n_map/3","title":"n_map(soundserver, node_id, args \\\\ [])"},{"anchor":"n_mapa/3","id":"n_mapa/3","title":"n_mapa(soundserver, node_id, args \\\\ [])"},{"anchor":"n_mapan/3","id":"n_mapan/3","title":"n_mapan(soundserver, node_id, args \\\\ [])"},{"anchor":"n_mapn/3","id":"n_mapn/3","title":"n_mapn(soundserver, node_id, args \\\\ [])"},{"anchor":"n_order/4","id":"n_order/4","title":"n_order(soundserver, add_action_code, add_target_id, node_ids \\\\ [])"},{"anchor":"n_query/2","id":"n_query/2","title":"n_query(soundserver, node_id)"},{"anchor":"n_run/3","id":"n_run/3","title":"n_run(soundserver, node_id, run_flag)"},{"anchor":"n_set/3","id":"n_set/3","title":"n_set(soundserver, node_id, args \\\\ [])"},{"anchor":"n_setn/3","id":"n_setn/3","title":"n_setn(soundserver, node_id, args \\\\ [])"},{"anchor":"n_trace/2","id":"n_trace/2","title":"n_trace(soundserver, node_id)"}]},{"key":"group-commands","name":"Group commands","nodes":[{"anchor":"g_deep_free/2","id":"g_deep_free/2","title":"g_deep_free(soundserver, group_id)"},{"anchor":"g_dump_tree/3","id":"g_dump_tree/3","title":"g_dump_tree(soundserver, group_id, flag_code \\\\ 1)"},{"anchor":"g_free_all/2","id":"g_free_all/2","title":"g_free_all(soundserver, group_id)"},{"anchor":"g_head/4","id":"g_head/4","title":"g_head(soundserver, node_id, group_id, node_id)"},{"anchor":"g_new/4","id":"g_new/4","title":"g_new(soundserver, node_id, add_action_id, target_node_id)"},{"anchor":"g_query_tree/3","id":"g_query_tree/3","title":"g_query_tree(soundserver, group_id, flag_code \\\\ 1)"},{"anchor":"g_tail/4","id":"g_tail/4","title":"g_tail(soundserver, node_id, group_id, node_id)"},{"anchor":"p_new/4","id":"p_new/4","title":"p_new(soundserver, node_id, add_action_id, target_node_id)"}]},{"key":"unit-generator-commands","name":"Unit generator commands","nodes":[{"anchor":"u_cmd/5","id":"u_cmd/5","title":"u_cmd(soundserver, node_id, ug_index, command_name, args \\\\ [])"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"dump_OSC/2","id":"dump_OSC/2","title":"dump_OSC(soundserver, code)"},{"anchor":"free_node/2","id":"free_node/2","title":"free_node(soundserver, node_id)"},{"anchor":"synth/2","id":"synth/2","title":"synth(soundserver, attr \\\\ [])"},{"anchor":"tone/1","id":"tone/1","title":"tone(soundserver)"}]}],"sections":[{"anchor":"module-structure-of-this-module","id":"Structure of this module"}],"title":"SuperCollider.SoundServer.Command"},{"group":"Server","id":"SuperCollider.SoundServer.Response","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"process_osc_message/2","id":"process_osc_message/2","title":"process_osc_message(soundserver, res)"}]}],"sections":[],"title":"SuperCollider.SoundServer.Response"},{"group":"Helpers","id":"SuperCollider.SynthDef.Encoder","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"write_8/1","id":"write_8/1","title":"write_8(num)"},{"anchor":"write_16/1","id":"write_16/1","title":"write_16(num)"},{"anchor":"write_32/1","id":"write_32/1","title":"write_32(num)"},{"anchor":"write_float/1","id":"write_float/1","title":"write_float(num)"},{"anchor":"write_floats/1","id":"write_floats/1","title":"write_floats(numbers)"},{"anchor":"write_name_float_pairs/1","id":"write_name_float_pairs/1","title":"write_name_float_pairs(name_value_pairs)"},{"anchor":"write_name_integer_pairs/1","id":"write_name_integer_pairs/1","title":"write_name_integer_pairs(name_value_pairs)"},{"anchor":"write_pstring/1","id":"write_pstring/1","title":"write_pstring(string)"}]}],"sections":[],"title":"SuperCollider.SynthDef.Encoder"},{"group":"Helpers","id":"SuperCollider.SynthDef.Parser","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"parse_floats/2","id":"parse_floats/2","title":"parse_floats(binary, number)"},{"anchor":"parse_integer_16/1","id":"parse_integer_16/1","title":"parse_integer_16(binary)"},{"anchor":"parse_integer_32/1","id":"parse_integer_32/1","title":"parse_integer_32(binary)"},{"anchor":"parse_name_float_pairs/2","id":"parse_name_float_pairs/2","title":"parse_name_float_pairs(binary, number)"},{"anchor":"parse_name_integer_pairs/2","id":"parse_name_integer_pairs/2","title":"parse_name_integer_pairs(binary, number)"},{"anchor":"parse_pstring/1","id":"parse_pstring/1","title":"parse_pstring(binary)"}]}],"sections":[],"title":"SuperCollider.SynthDef.Parser"},{"group":"Helpers","id":"SuperCollider.SynthDef.ScFile","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"decode/1","id":"decode/1","title":"decode(binary)"},{"anchor":"encode/1","id":"encode/1","title":"encode(synthdefs)"},{"anchor":"parse/1","id":"parse/1","title":"parse(filename)"}]}],"sections":[{"anchor":"module-example","id":"Example"}],"title":"SuperCollider.SynthDef.ScFile"}],"tasks":[]}